# @(#)fix_project.pl	1.9 04/05/11 17:02:50
#
# Copyright  1990-2006 Sun Microsystems, Inc. All Rights Reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License version
# 2 only, as published by the Free Software Foundation. 
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License version 2 for more details (a copy is
# included at /legal/license.txt). 
# 
# You should have received a copy of the GNU General Public License
# version 2 along with this work; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
# 02110-1301 USA 
# 
# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
# Clara, CA 95054 or visit www.sun.com if you need additional
# information or have any questions. 

# Fix project files generated by the Symbian abld.bat script.
#
# We mostly use the project files generated by abld.bat 'as is'.
# However, when there's no other way to do what we want, we have to
# change the generate makefile. See comments below to see what we
# need to do.

$SYMBIAN_ROOT      = shift;
$BuildSpace        = shift;
$SYMBIAN_PLATFORM  = shift;
$CVM               = shift;

# change to unix slash, and clean trailing /
$SYMBIAN_ROOT =~ s:\\:/:g;
$SYMBIAN_ROOT =~ s:/+$::g;

# Trim leading drive name from BuildSpace
$BuildSpace =~ s@^[A-Za-z]:/@@g;

$BUILD_DIR  = "$SYMBIAN_ROOT/epoc32/build/$BuildSpace/$CVM/$SYMBIAN_PLATFORM";
$MAKEFILE   = "$BUILD_DIR/$CVM.$SYMBIAN_PLATFORM";

system("cp $MAKEFILE $MAKEFILE.orig") == 0
    or die "cp $MAKEFILE $MAKEFILE.orig failed.\n";
open(IN,  "$MAKEFILE.orig")
    or die "Can't open $MAKEFILE.orig for reading: $!.\n";
open(OUT, ">$MAKEFILE")
    or die "Can't open $MAKEFILE for writing: $!.\n";

while ($_ = <IN>) {
    if (($SYMBIAN_PLATFORM eq "wins") || ($SYMBIAN_PLATFORM eq "winc")) {
        # Fix the WINS/WINC makefile generated by abld.bat
        if ($SYMBIAN_PLATFORM eq "wins") {
            # This makes it possible to print directly to DOS console
            s/subsystem\:windows/subsystem\:console/g;
        }
    }

    # Symbian build tool generates makefile that use -J for both system
    # include path and user include path. That causes problem when the
    # compiler searches for include files. ARM compiler expects system
    # include path is specified by -J, and user include path is specified
    # by -I. Fix the generated makefile here.
    if (($SYMBIAN_PLATFORM eq "armv5")) {
        s/-J(?= \S*\\src\\share )/-I/g;
        s/-J(?= \S*\\build\\symbian-arm-\w+ )/-I/g;
        s/-J(?= \S*\\src\\share\\javavm\\export )/-I/g;
        s/-J(?= \S*\\src\\share\\native\\common )/-I/g;
        s/-J(?= \S*\\src\\share\\native\\java\\lang )/-I/g;
        s/-J(?= \S*\\src\\share\\native\\java\\lang\\fdlibm\\include )/-I/g;
        s/-J(?= \S*\\src\\share\\native\\java\\net )/-I/g;
        s/-J(?= \S*\\src\\share\\native\\java\\io )/-I/g;
        s/-J(?= \S*\\src\\share\\native\\java\\util\\zip )/-I/g;
        s/-J(?= \S*\\src\\share\\native\\java\\util\\zip\\zlib-1.1.3 )/-I/g;
        s/-J(?= \S*\\build\\symbian-arm-\w+\\generated\\jni )/-I/g;
        s/-J(?= \S*\\src\\arm )/-I/g;
        s/-J(?= \S*\\src )/-I/g;
        s/-J(?= \S*\\src\\symbian )/-I/g;
        s/-J(?= \S*\\src\\symbian\\native\\java\\net )/-I/g;
        s/-J(?= \S*\\src\\symbian\\native\\common )/-I/g;
        s/-J(?= \S*\\src\\symbian\\native\\cdc )/-I/g;
        s/-J(?= \S*\\src\\symbian-arm )/-I/g;
    }

    print OUT $_;
}

close(IN);
close(OUT);

print("fixed $MAKEFILE\n");

