/*
 * @(#)CharacterData.c	1.7 06/10/10
 * 
 * Copyright  1990-2006 Sun Microsystems, Inc. All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 only, as published by the Free Software Foundation. 
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License version 2 for more details (a copy is
 * included at /legal/license.txt). 
 * 
 * You should have received a copy of the GNU General Public License
 * version 2 along with this work; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA 
 * 
 * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
 * Clara, CA 95054 or visit www.sun.com if you need additional
 * information or have any questions. 
 */

#include "javavm/include/defs.h"
#include "javavm/include/objects.h"
#include "javavm/include/classes.h"
#include "javavm/include/directmem.h"
#include "javavm/include/indirectmem.h"
#include "javavm/include/localroots.h"
#include "javavm/export/jvm.h"
#include "generated/jni/java_lang_Character.h"
#include "javavm/include/preloader_impl.h"
#include "native/common/jni_util.h"

/* 
 * The static final arrays of bytes that make up the X, Y and A arrays of
 * java.lang.Character
 * 
 * This C file saves us the extra static initializer space for that class
 */
static const struct { 
    CVMObjectHeader hdr;
    CVMJavaInt length;
    CVMJavaChar charData[2048]; 
} CVM_CharacterX_data = {
	CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
        2048, {
            0, 1, 2, 3, 4, 5, 6, 7, 
            8, 9, 10, 11, 12, 13, 14, 15, 
            8, 16, 17, 18, 19, 20, 21, 22, 
            23, 23, 24, 25, 26, 27, 28, 29, 
            30, 31, 32, 8, 33, 8, 34, 35, 
            36, 37, 38, 39, 40, 41, 42, 43, 
            44, 45, 46, 47, 48, 48, 49, 50, 
            51, 52, 53, 36, 48, 54, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            55, 56, 57, 58, 59, 60, 61, 62, 
            63, 64, 65, 66, 67, 68, 69, 70, 
            59, 71, 72, 73, 74, 75, 76, 77, 
            78, 79, 80, 81, 82, 83, 84, 81, 
            82, 85, 86, 81, 87, 88, 89, 90, 
            91, 92, 93, 36, 94, 95, 96, 36, 
            97, 98, 99, 100, 101, 102, 103, 36, 
            104, 105, 106, 36, 36, 107, 108, 109, 
            104, 104, 110, 104, 104, 111, 104, 112, 
            113, 104, 114, 104, 115, 116, 117, 118, 
            116, 104, 119, 120, 36, 104, 104, 121, 
            91, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 122, 123, 104, 104, 124, 
            36, 36, 36, 36, 104, 125, 126, 127, 
            128, 104, 129, 130, 104, 131, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            8, 8, 8, 8, 132, 8, 8, 133, 
            134, 135, 136, 137, 138, 139, 140, 141, 
            142, 143, 144, 145, 146, 147, 148, 149, 
            150, 151, 152, 153, 154, 155, 156, 157, 
            158, 159, 160, 161, 162, 163, 164, 165, 
            166, 167, 168, 169, 170, 36, 36, 36, 
            171, 172, 173, 174, 175, 176, 177, 178, 
            171, 171, 171, 171, 179, 180, 181, 182, 
            183, 171, 171, 184, 36, 36, 36, 36, 
            185, 186, 187, 188, 189, 190, 36, 36, 
            171, 171, 171, 171, 171, 171, 171, 171, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 191, 171, 171, 157, 
            171, 171, 171, 171, 171, 171, 179, 192, 
            193, 194, 91, 104, 195, 91, 104, 196, 
            197, 198, 104, 104, 199, 130, 36, 36, 
            200, 201, 202, 203, 204, 205, 206, 207, 
            168, 168, 168, 208, 168, 168, 209, 207, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 210, 36, 36, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 211, 36, 36, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 212, 213, 214, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 36, 36, 36, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 104, 104, 104, 104, 215, 36, 36, 
            216, 216, 216, 216, 216, 216, 216, 216, 
            216, 216, 216, 216, 216, 216, 216, 216, 
            216, 216, 216, 216, 216, 216, 216, 216, 
            216, 216, 216, 216, 216, 216, 216, 216, 
            216, 216, 216, 216, 216, 216, 216, 216, 
            216, 216, 216, 216, 216, 216, 216, 216, 
            216, 216, 216, 216, 216, 216, 216, 216, 
            216, 216, 216, 216, 216, 216, 216, 216, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            217, 217, 217, 217, 217, 217, 217, 217, 
            104, 104, 104, 104, 104, 104, 104, 104, 
            104, 218, 36, 36, 36, 36, 36, 36, 
            219, 220, 221, 48, 48, 222, 223, 48, 
            48, 48, 48, 48, 48, 48, 48, 48, 
            48, 224, 225, 48, 226, 48, 227, 228, 
            36, 229, 230, 231, 48, 48, 48, 232, 
            233, 234, 235, 236, 237, 238, 239, 240, 
        }
};

static const struct { 
    CVMObjectHeader hdr;
    CVMJavaInt	length;
    CVMJavaChar charData[3856]; 
} CVM_CharacterY_data = {
    CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfShort_Classblock,0),
        3856, {
            0, 0, 0, 0, 2, 4, 6, 0, 
            0, 0, 0, 0, 0, 0, 8, 4, 
            10, 12, 14, 16, 18, 20, 22, 24, 
            26, 26, 26, 26, 26, 28, 30, 32, 
            34, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 38, 40, 42, 
            44, 46, 46, 46, 46, 46, 46, 46, 
            46, 46, 46, 46, 46, 48, 50, 52, 
            0, 0, 54, 0, 0, 0, 0, 0, 
            0, 0, 0, 0, 0, 0, 0, 0, 
            56, 58, 58, 60, 62, 64, 66, 68, 
            70, 72, 74, 76, 78, 80, 82, 84, 
            86, 86, 86, 86, 86, 86, 86, 86, 
            86, 86, 86, 88, 86, 86, 86, 90, 
            92, 92, 92, 92, 92, 92, 92, 92, 
            92, 92, 92, 94, 92, 92, 92, 96, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            100, 98, 98, 98, 102, 104, 104, 104, 
            104, 104, 104, 104, 106, 98, 98, 98, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 98, 98, 108, 104, 104, 106, 
            110, 98, 98, 112, 114, 116, 118, 120, 
            122, 114, 124, 126, 98, 128, 130, 132, 
            98, 98, 98, 134, 136, 128, 98, 134, 
            138, 140, 104, 142, 98, 144, 98, 146, 
            148, 148, 150, 152, 154, 150, 156, 104, 
            104, 104, 104, 104, 104, 104, 158, 98, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            160, 154, 98, 162, 98, 98, 98, 98, 
            164, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            128, 166, 168, 170, 172, 174, 128, 128, 
            176, 178, 128, 128, 180, 128, 128, 182, 
            128, 184, 186, 128, 128, 128, 128, 128, 
            188, 190, 128, 128, 188, 192, 128, 128, 
            128, 194, 128, 128, 128, 128, 128, 128, 
            128, 128, 128, 128, 128, 128, 128, 164, 
            196, 196, 196, 196, 198, 200, 196, 196, 
            196, 202, 202, 202, 202, 202, 202, 202, 
            196, 202, 202, 202, 202, 202, 202, 202, 
            196, 196, 198, 202, 202, 202, 202, 204, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            206, 206, 206, 206, 206, 206, 206, 206, 
            206, 206, 206, 206, 206, 206, 206, 206, 
            206, 206, 208, 206, 206, 206, 206, 210, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            206, 210, 164, 164, 164, 164, 164, 164, 
            164, 164, 202, 164, 164, 204, 164, 212, 
            164, 164, 202, 214, 216, 218, 220, 222, 
            224, 86, 86, 86, 86, 86, 86, 86, 
            86, 226, 86, 86, 86, 86, 228, 230, 
            232, 92, 92, 92, 92, 92, 92, 92, 
            92, 234, 92, 92, 92, 92, 236, 238, 
            240, 242, 244, 246, 164, 98, 98, 98, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            248, 250, 164, 164, 164, 164, 164, 164, 
            252, 252, 252, 252, 252, 252, 252, 252, 
            86, 86, 86, 86, 86, 86, 86, 86, 
            86, 86, 86, 86, 86, 86, 86, 86, 
            92, 92, 92, 92, 92, 92, 92, 92, 
            92, 92, 92, 92, 92, 92, 92, 92, 
            254, 254, 254, 254, 254, 254, 254, 254, 
            98, 256, 206, 210, 258, 164, 98, 98, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            260, 104, 262, 264, 262, 264, 262, 164, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 98, 164, 98, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            266, 268, 268, 268, 268, 268, 268, 268, 
            268, 268, 268, 268, 268, 268, 268, 268, 
            268, 268, 268, 270, 272, 274, 274, 274, 
            276, 278, 278, 278, 278, 278, 278, 278, 
            278, 278, 278, 278, 278, 278, 278, 278, 
            278, 278, 278, 280, 282, 284, 164, 164, 
            286, 206, 206, 206, 206, 206, 206, 206, 
            206, 286, 206, 206, 206, 206, 206, 206, 
            206, 206, 206, 206, 206, 286, 206, 288, 
            288, 290, 210, 164, 164, 164, 164, 164, 
            292, 292, 292, 292, 292, 292, 292, 292, 
            292, 292, 292, 292, 292, 294, 164, 164, 
            292, 296, 298, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 300, 164, 
            164, 164, 164, 164, 164, 302, 164, 302, 
            304, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 308, 164, 164, 
            310, 306, 306, 306, 306, 312, 206, 206, 
            206, 206, 206, 164, 164, 164, 164, 164, 
            314, 314, 314, 314, 314, 316, 318, 164, 
            320, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 322, 206, 206, 206, 324, 326, 
            206, 206, 328, 330, 332, 206, 206, 164, 
            26, 26, 26, 26, 26, 306, 334, 336, 
            338, 338, 338, 338, 338, 338, 338, 340, 
            312, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 308, 164, 
            206, 206, 206, 206, 206, 206, 206, 206, 
            206, 206, 206, 206, 206, 210, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            306, 306, 306, 206, 206, 206, 206, 206, 
            210, 164, 164, 164, 164, 164, 164, 164, 
            286, 342, 344, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 164, 346, 348, 
            350, 206, 206, 206, 342, 348, 350, 164, 
            352, 206, 210, 164, 148, 148, 148, 148, 
            148, 206, 274, 354, 354, 354, 354, 354, 
            356, 164, 164, 164, 164, 164, 164, 164, 
            286, 348, 344, 148, 148, 148, 358, 344, 
            358, 344, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 358, 148, 148, 148, 
            358, 358, 164, 148, 148, 164, 210, 348, 
            350, 206, 210, 360, 362, 360, 350, 164, 
            164, 164, 164, 360, 164, 164, 148, 344, 
            148, 206, 164, 354, 354, 354, 354, 354, 
            148, 58, 364, 364, 366, 368, 164, 164, 
            164, 210, 344, 148, 148, 358, 164, 344, 
            358, 344, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 358, 148, 148, 148, 
            358, 148, 344, 358, 148, 164, 210, 348, 
            350, 210, 164, 286, 210, 286, 206, 164, 
            164, 164, 164, 164, 344, 148, 358, 358, 
            164, 164, 164, 354, 354, 354, 354, 354, 
            206, 148, 358, 164, 164, 164, 164, 164, 
            286, 342, 344, 148, 148, 148, 344, 344, 
            148, 344, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 358, 148, 148, 148, 
            358, 148, 344, 148, 148, 164, 346, 348, 
            350, 206, 206, 286, 342, 360, 350, 164, 
            358, 164, 164, 164, 164, 164, 164, 164, 
            358, 164, 164, 354, 354, 354, 354, 354, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            148, 148, 148, 148, 358, 148, 148, 148, 
            358, 148, 164, 148, 148, 164, 346, 350, 
            350, 206, 164, 360, 362, 360, 350, 164, 
            164, 164, 164, 342, 164, 164, 148, 344, 
            148, 164, 164, 354, 354, 354, 354, 354, 
            368, 164, 164, 164, 164, 164, 164, 164, 
            164, 342, 344, 148, 148, 358, 164, 148, 
            358, 148, 148, 164, 344, 358, 358, 148, 
            164, 344, 358, 164, 148, 358, 164, 148, 
            148, 148, 148, 344, 148, 164, 164, 348, 
            342, 362, 164, 348, 362, 348, 350, 164, 
            164, 164, 164, 360, 164, 164, 164, 164, 
            164, 164, 164, 370, 354, 354, 354, 354, 
            372, 374, 164, 164, 164, 164, 164, 164, 
            360, 348, 344, 148, 148, 148, 358, 148, 
            358, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 358, 148, 148, 148, 
            148, 148, 344, 148, 148, 164, 164, 206, 
            342, 348, 362, 206, 210, 206, 206, 164, 
            164, 164, 286, 210, 164, 164, 164, 164, 
            148, 164, 164, 354, 354, 354, 354, 354, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 348, 344, 148, 148, 148, 358, 148, 
            358, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 358, 148, 148, 148, 
            148, 148, 344, 148, 148, 164, 164, 350, 
            348, 348, 362, 342, 362, 348, 206, 164, 
            164, 164, 360, 362, 164, 164, 164, 358, 
            148, 148, 148, 148, 358, 148, 148, 148, 
            148, 148, 148, 148, 148, 164, 164, 348, 
            350, 206, 164, 348, 362, 348, 350, 164, 
            164, 164, 164, 360, 164, 164, 164, 164, 
            164, 348, 344, 148, 148, 148, 148, 148, 
            148, 148, 148, 358, 164, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 344, 148, 148, 148, 148, 344, 164, 
            148, 148, 148, 358, 164, 210, 164, 360, 
            348, 206, 210, 210, 348, 348, 348, 348, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 348, 356, 164, 164, 164, 164, 164, 
            344, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            352, 148, 206, 206, 206, 210, 164, 376, 
            148, 148, 148, 378, 206, 206, 206, 380, 
            382, 382, 382, 382, 382, 274, 164, 164, 
            344, 358, 358, 344, 358, 358, 344, 164, 
            164, 164, 148, 148, 344, 148, 148, 148, 
            344, 148, 344, 344, 164, 148, 344, 148, 
            352, 148, 206, 206, 206, 286, 346, 164, 
            148, 148, 358, 204, 206, 206, 206, 164, 
            382, 382, 382, 382, 382, 164, 148, 164, 
            384, 386, 274, 274, 274, 274, 274, 274, 
            274, 388, 386, 386, 206, 386, 386, 386, 
            390, 390, 390, 390, 390, 392, 392, 392, 
            392, 392, 256, 256, 256, 394, 394, 348, 
            148, 148, 148, 148, 344, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 358, 164, 164, 
            286, 206, 206, 206, 206, 206, 206, 342, 
            206, 206, 380, 206, 148, 148, 164, 164, 
            206, 206, 206, 206, 286, 206, 206, 206, 
            206, 206, 206, 206, 206, 206, 206, 206, 
            206, 206, 206, 206, 206, 206, 210, 386, 
            386, 386, 386, 396, 386, 386, 368, 398, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 344, 148, 148, 344, 358, 350, 206, 
            342, 210, 164, 206, 350, 164, 164, 164, 
            390, 390, 390, 390, 390, 274, 274, 274, 
            148, 148, 148, 348, 206, 164, 164, 164, 
            242, 242, 242, 242, 242, 242, 242, 242, 
            242, 242, 242, 242, 242, 242, 242, 242, 
            242, 242, 242, 164, 164, 164, 164, 164, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 358, 164, 282, 164, 164, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 164, 164, 344, 
            148, 358, 164, 164, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 164, 164, 164, 
            148, 148, 148, 358, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 358, 358, 148, 148, 164, 
            148, 148, 148, 358, 358, 148, 148, 164, 
            148, 148, 148, 358, 358, 148, 148, 164, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 358, 
            358, 148, 148, 164, 148, 148, 148, 358, 
            358, 148, 148, 164, 148, 148, 148, 358, 
            148, 148, 148, 358, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 358, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 358, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 358, 164, 164, 
            282, 274, 274, 274, 400, 402, 402, 402, 
            402, 404, 406, 408, 408, 408, 374, 164, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 358, 164, 164, 164, 164, 164, 
            148, 148, 148, 148, 148, 148, 410, 412, 
            148, 148, 148, 358, 164, 164, 164, 164, 
            414, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 416, 418, 164, 
            148, 148, 148, 148, 148, 410, 274, 420, 
            422, 164, 164, 164, 164, 164, 164, 164, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 348, 350, 206, 206, 206, 348, 
            348, 348, 348, 342, 350, 206, 206, 206, 
            206, 206, 274, 274, 274, 424, 356, 164, 
            390, 390, 390, 390, 390, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            16, 16, 16, 426, 16, 428, 430, 432, 
            382, 382, 382, 382, 382, 164, 164, 164, 
            148, 434, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 164, 164, 164, 164, 
            148, 148, 148, 148, 352, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 98, 436, 436, 438, 164, 164, 
            98, 98, 98, 98, 98, 98, 98, 98, 
            98, 98, 98, 98, 98, 164, 164, 164, 
            440, 440, 440, 440, 442, 442, 442, 442, 
            440, 440, 440, 164, 442, 442, 442, 164, 
            440, 440, 440, 440, 442, 442, 442, 442, 
            440, 440, 440, 440, 442, 442, 442, 442, 
            440, 440, 440, 164, 442, 442, 442, 164, 
            444, 444, 444, 444, 446, 446, 446, 446, 
            440, 440, 440, 440, 442, 442, 442, 442, 
            448, 450, 450, 452, 454, 456, 458, 164, 
            436, 436, 436, 436, 460, 460, 460, 460, 
            436, 436, 436, 436, 460, 460, 460, 460, 
            436, 436, 436, 436, 460, 460, 460, 460, 
            440, 436, 462, 436, 442, 464, 466, 468, 
            202, 436, 462, 436, 470, 470, 466, 202, 
            440, 436, 164, 436, 442, 472, 474, 202, 
            440, 436, 476, 436, 442, 478, 480, 202, 
            164, 436, 462, 436, 482, 484, 466, 486, 
            488, 488, 488, 490, 488, 492, 430, 494, 
            496, 496, 496, 16, 498, 500, 498, 500, 
            16, 16, 16, 16, 502, 504, 504, 506, 
            508, 508, 510, 16, 512, 514, 16, 516, 
            518, 16, 520, 522, 16, 16, 16, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 430, 430, 430, 
            524, 164, 72, 72, 72, 526, 520, 528, 
            530, 530, 530, 530, 530, 526, 520, 522, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            58, 58, 58, 58, 58, 58, 58, 58, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            206, 206, 206, 206, 206, 206, 324, 258, 
            326, 258, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            60, 532, 60, 534, 60, 536, 242, 128, 
            242, 538, 534, 60, 534, 242, 242, 60, 
            60, 60, 532, 540, 532, 542, 242, 544, 
            242, 534, 144, 148, 546, 548, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 550, 82, 82, 82, 82, 82, 82, 
            552, 552, 552, 552, 552, 552, 554, 554, 
            556, 556, 556, 556, 556, 556, 558, 558, 
            560, 562, 164, 164, 164, 164, 164, 164, 
            564, 564, 566, 60, 60, 564, 60, 60, 
            566, 568, 60, 566, 60, 60, 60, 566, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 564, 
            60, 566, 566, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 164, 164, 164, 164, 164, 164, 
            570, 572, 30, 564, 572, 572, 572, 564, 
            570, 526, 570, 30, 564, 572, 572, 570, 
            572, 30, 30, 30, 564, 570, 572, 572, 
            572, 572, 564, 564, 570, 570, 572, 572, 
            572, 572, 572, 572, 572, 572, 30, 564, 
            564, 572, 572, 564, 564, 564, 564, 570, 
            30, 30, 572, 572, 572, 572, 564, 572, 
            572, 572, 572, 572, 572, 572, 572, 572, 
            572, 572, 572, 572, 572, 572, 30, 570, 
            572, 30, 564, 564, 30, 564, 564, 564, 
            564, 572, 564, 572, 572, 572, 572, 572, 
            572, 572, 572, 572, 30, 564, 564, 572, 
            564, 564, 564, 564, 570, 572, 572, 564, 
            572, 564, 564, 572, 572, 572, 572, 572, 
            572, 572, 572, 572, 572, 572, 572, 564, 
            572, 164, 164, 164, 164, 164, 164, 164, 
            60, 60, 60, 60, 572, 572, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            572, 60, 60, 60, 574, 576, 60, 60, 
            60, 60, 60, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 578, 580, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 582, 60, 60, 548, 164, 164, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 548, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            60, 60, 60, 60, 60, 548, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            584, 584, 584, 584, 584, 584, 584, 584, 
            584, 584, 586, 586, 586, 586, 586, 586, 
            586, 586, 586, 586, 588, 588, 588, 588, 
            588, 588, 588, 588, 588, 588, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 590, 590, 590, 590, 590, 
            590, 590, 590, 590, 590, 590, 590, 590, 
            592, 592, 592, 592, 592, 592, 592, 592, 
            592, 592, 592, 592, 592, 594, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 164, 164, 164, 164, 164, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 568, 60, 60, 60, 60, 
            568, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 164, 164, 164, 164, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 164, 164, 580, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 568, 
            60, 164, 164, 164, 164, 164, 164, 164, 
            580, 60, 548, 60, 60, 164, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 580, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 580, 580, 
            60, 548, 164, 548, 60, 60, 60, 548, 
            580, 60, 60, 60, 164, 164, 164, 164, 
            164, 164, 164, 596, 596, 596, 596, 596, 
            598, 598, 598, 598, 598, 600, 600, 600, 
            600, 600, 548, 164, 60, 60, 60, 60, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            580, 60, 60, 60, 60, 60, 60, 548, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 60, 60, 60, 60, 580, 60, 60, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            60, 60, 60, 60, 60, 60, 164, 164, 
            10, 16, 602, 604, 18, 18, 18, 18, 
            18, 60, 18, 18, 18, 18, 606, 608, 
            610, 612, 612, 612, 612, 206, 206, 206, 
            614, 196, 196, 60, 616, 618, 164, 60, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 358, 164, 286, 620, 200, 204, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 622, 196, 204, 
            164, 164, 344, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 358, 164, 
            344, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 358, 
            386, 392, 392, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 368, 164, 
            392, 392, 392, 392, 392, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 164, 398, 
            624, 624, 624, 624, 624, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            368, 164, 164, 164, 164, 164, 164, 164, 
            386, 386, 386, 386, 386, 386, 164, 164, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 368, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 368, 164, 398, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 386, 
            386, 386, 386, 386, 386, 386, 386, 164, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 164, 164, 164, 164, 164, 
            148, 148, 148, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            148, 148, 148, 148, 148, 148, 358, 164, 
            60, 60, 60, 60, 60, 60, 60, 60, 
            60, 164, 60, 60, 60, 60, 60, 60, 
            60, 60, 580, 60, 60, 60, 60, 60, 
            548, 60, 548, 548, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            148, 148, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            626, 626, 626, 626, 626, 626, 626, 626, 
            626, 626, 626, 626, 626, 626, 626, 626, 
            628, 628, 628, 628, 628, 628, 628, 628, 
            628, 628, 628, 628, 628, 628, 628, 628, 
            148, 148, 148, 148, 148, 148, 148, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            436, 436, 436, 462, 164, 164, 164, 164, 
            164, 630, 436, 436, 164, 164, 632, 634, 
            292, 292, 292, 292, 636, 292, 292, 292, 
            292, 292, 292, 294, 292, 292, 294, 294, 
            292, 632, 294, 292, 292, 292, 292, 292, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            306, 164, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 304, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 306, 394, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            164, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            164, 164, 164, 164, 164, 164, 164, 164, 
            306, 306, 306, 306, 306, 306, 164, 164, 
            206, 206, 164, 164, 164, 164, 164, 164, 
            638, 640, 642, 644, 644, 644, 644, 644, 
            644, 644, 418, 164, 646, 16, 516, 648, 
            28, 300, 650, 16, 606, 644, 644, 652, 
            16, 654, 564, 656, 658, 510, 164, 164, 
            306, 308, 308, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 306, 306, 
            306, 306, 306, 306, 306, 306, 308, 340, 
            646, 12, 14, 16, 394, 20, 22, 24, 
            26, 26, 26, 26, 26, 28, 564, 660, 
            34, 36, 36, 36, 36, 36, 36, 36, 
            36, 36, 36, 36, 36, 662, 664, 42, 
            44, 46, 46, 46, 46, 46, 46, 46, 
            46, 46, 46, 46, 46, 666, 668, 656, 
            646, 394, 516, 148, 148, 148, 148, 148, 
            670, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 196, 
            148, 148, 148, 148, 148, 148, 148, 148, 
            148, 148, 148, 148, 148, 148, 148, 358, 
            164, 148, 148, 148, 164, 148, 148, 148, 
            164, 148, 148, 148, 164, 148, 358, 164, 
            58, 672, 674, 676, 568, 564, 566, 548, 
            164, 164, 164, 164, 340, 430, 60, 164, 
        }
};

static const struct { 
    CVMObjectHeader hdr;
    CVMJavaInt	length;
    CVMJavaInt intData[678]; 
} CVM_CharacterA_data = {
    CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfInt_Classblock,0),
        678, {
            (CVMJavaInt)0x4800100F,
            (CVMJavaInt)0x4800100F,
            (CVMJavaInt)0x4800100F,
            (CVMJavaInt)0x5800400F,
            (CVMJavaInt)0x5000400F,
            (CVMJavaInt)0x5800400F,
            (CVMJavaInt)0x6000400F,
            (CVMJavaInt)0x5000400F,
            (CVMJavaInt)0x5000400F,
            (CVMJavaInt)0x5000400F,
            (CVMJavaInt)0x6000400C,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x28000018,
            (CVMJavaInt)0x2800601A,
            (CVMJavaInt)0x28000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)-0x17FFFFEB,
            (CVMJavaInt)-0x17FFFFEA,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x28000019,
            (CVMJavaInt)0x38000018,
            (CVMJavaInt)0x28000014,
            (CVMJavaInt)0x38000018,
            (CVMJavaInt)0x20000018,
            (CVMJavaInt)0x18003609,
            (CVMJavaInt)0x18003609,
            (CVMJavaInt)0x38000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)-0x17FFFFE7,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)-0x17FFFFE7,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x00827FE1,
            (CVMJavaInt)0x00827FE1,
            (CVMJavaInt)0x00827FE1,
            (CVMJavaInt)0x00827FE1,
            (CVMJavaInt)-0x17FFFFEB,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)-0x17FFFFEA,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x68005017,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x00817FE2,
            (CVMJavaInt)0x00817FE2,
            (CVMJavaInt)0x00817FE2,
            (CVMJavaInt)0x00817FE2,
            (CVMJavaInt)-0x17FFFFEB,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)-0x17FFFFEA,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x4800100F,
            (CVMJavaInt)0x4800100F,
            (CVMJavaInt)0x5000100F,
            (CVMJavaInt)0x3800000C,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x2800601A,
            (CVMJavaInt)0x2800601A,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)-0x17FFFFE3,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x2800001C,
            (CVMJavaInt)0x28000019,
            (CVMJavaInt)0x1800060B,
            (CVMJavaInt)0x1800060B,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x1800050B,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)-0x17FFFFE2,
            (CVMJavaInt)0x6800080B,
            (CVMJavaInt)0x6800080B,
            (CVMJavaInt)0x6800080B,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x00827001,
            (CVMJavaInt)0x00827001,
            (CVMJavaInt)0x00827001,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x00827001,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x00817002,
            (CVMJavaInt)0x00817002,
            (CVMJavaInt)0x00817002,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x00817002,
            (CVMJavaInt)0x061D7002,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x04E67001,
            (CVMJavaInt)0x03A17002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x061E7001,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x034A7001,
            (CVMJavaInt)0x033A7001,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x03367001,
            (CVMJavaInt)0x03367001,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x013E7001,
            (CVMJavaInt)0x032A7001,
            (CVMJavaInt)0x032E7001,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x033E7001,
            (CVMJavaInt)0x067D7002,
            (CVMJavaInt)0x034E7001,
            (CVMJavaInt)0x03467001,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x034E7001,
            (CVMJavaInt)0x03567001,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x035A7001,
            (CVMJavaInt)0x036A7001,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x036A7001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x03667001,
            (CVMJavaInt)0x03667001,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x036E7001,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x07217002,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x000AF001,
            (CVMJavaInt)0x0007F003,
            (CVMJavaInt)0x0009F002,
            (CVMJavaInt)0x000AF001,
            (CVMJavaInt)0x0007F003,
            (CVMJavaInt)0x0009F002,
            (CVMJavaInt)0x0009F002,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x013D7002,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x000AF001,
            (CVMJavaInt)0x067E7001,
            (CVMJavaInt)0x07227001,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x03497002,
            (CVMJavaInt)0x03397002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x03357002,
            (CVMJavaInt)0x03357002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x03297002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x032D7002,
            (CVMJavaInt)0x03357002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x033D7002,
            (CVMJavaInt)0x03457002,
            (CVMJavaInt)0x034D7002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x034D7002,
            (CVMJavaInt)0x03557002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x03597002,
            (CVMJavaInt)0x03697002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x03697002,
            (CVMJavaInt)0x03657002,
            (CVMJavaInt)0x03657002,
            (CVMJavaInt)0x036D7002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x46B13006,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x009A7001,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x00967001,
            (CVMJavaInt)0x00967001,
            (CVMJavaInt)0x00967001,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x01027001,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00FE7001,
            (CVMJavaInt)0x00FE7001,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x00827001,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00827001,
            (CVMJavaInt)0x00997002,
            (CVMJavaInt)0x00957002,
            (CVMJavaInt)0x00957002,
            (CVMJavaInt)0x00957002,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x00817002,
            (CVMJavaInt)0x007D7002,
            (CVMJavaInt)0x00817002,
            (CVMJavaInt)0x01017002,
            (CVMJavaInt)0x00FD7002,
            (CVMJavaInt)0x00FD7002,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00F97002,
            (CVMJavaInt)0x00E57002,
            (CVMJavaInt)0x00007001,
            (CVMJavaInt)0x00007001,
            (CVMJavaInt)0x00007001,
            (CVMJavaInt)0x00BD7002,
            (CVMJavaInt)0x00D97002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x01597002,
            (CVMJavaInt)0x01417002,
            (CVMJavaInt)0x013D7002,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x01427001,
            (CVMJavaInt)0x01427001,
            (CVMJavaInt)0x01417002,
            (CVMJavaInt)0x01417002,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x40000007,
            (CVMJavaInt)0x40000007,
            (CVMJavaInt)0x00007001,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x00057002,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00067001,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00C27001,
            (CVMJavaInt)0x00C27001,
            (CVMJavaInt)0x00C27001,
            (CVMJavaInt)0x00C27001,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00C17002,
            (CVMJavaInt)0x00C17002,
            (CVMJavaInt)0x00C17002,
            (CVMJavaInt)0x00C17002,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x08000018,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x08000018,
            (CVMJavaInt)0x08007005,
            (CVMJavaInt)0x08007005,
            (CVMJavaInt)0x08007005,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x08007005,
            (CVMJavaInt)0x08000018,
            (CVMJavaInt)0x08000018,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x38000018,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x10000018,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x10007004,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x30003409,
            (CVMJavaInt)0x30003409,
            (CVMJavaInt)0x28000018,
            (CVMJavaInt)0x30000018,
            (CVMJavaInt)0x30000018,
            (CVMJavaInt)0x10000018,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x10000018,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x40000007,
            (CVMJavaInt)0x40000007,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x10007004,
            (CVMJavaInt)0x10007004,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x10007005,
            (CVMJavaInt)0x1000001C,
            (CVMJavaInt)0x1000001C,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x10000018,
            (CVMJavaInt)0x10000018,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x48001010,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x00003008,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x00003008,
            (CVMJavaInt)0x00003008,
            (CVMJavaInt)0x00003008,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x00003749,
            (CVMJavaInt)0x00003749,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00003008,
            (CVMJavaInt)0x00003008,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x000005AB,
            (CVMJavaInt)0x000005AB,
            (CVMJavaInt)0x0000000B,
            (CVMJavaInt)0x000006EB,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00003749,
            (CVMJavaInt)0x0000074B,
            (CVMJavaInt)0x0000080B,
            (CVMJavaInt)0x0000080B,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x2800601A,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x00003609,
            (CVMJavaInt)0x00003609,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x00003409,
            (CVMJavaInt)0x00003409,
            (CVMJavaInt)0x0000000B,
            (CVMJavaInt)0x0000000B,
            (CVMJavaInt)0x68000015,
            (CVMJavaInt)0x68000016,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x00003709,
            (CVMJavaInt)0x00003709,
            (CVMJavaInt)0x00003709,
            (CVMJavaInt)0x0000070B,
            (CVMJavaInt)0x0000042B,
            (CVMJavaInt)0x0000054B,
            (CVMJavaInt)0x0000080B,
            (CVMJavaInt)0x0000080B,
            (CVMJavaInt)0x0000080B,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x6000400C,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x68000015,
            (CVMJavaInt)0x68000016,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x0000046B,
            (CVMJavaInt)0x0000046B,
            (CVMJavaInt)0x0000046B,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00000018,
            (CVMJavaInt)0x2800601A,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x48001010,
            (CVMJavaInt)0x48001010,
            (CVMJavaInt)0x48001010,
            (CVMJavaInt)0x48001010,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x00ED7002,
            (CVMJavaInt)0x07E17002,
            (CVMJavaInt)0x07E17002,
            (CVMJavaInt)0x07E27001,
            (CVMJavaInt)0x07E27001,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x07E17002,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x07E27001,
            (CVMJavaInt)0x06D97002,
            (CVMJavaInt)0x06D97002,
            (CVMJavaInt)0x06A97002,
            (CVMJavaInt)0x06A97002,
            (CVMJavaInt)0x06717002,
            (CVMJavaInt)0x06717002,
            (CVMJavaInt)0x06017002,
            (CVMJavaInt)0x06017002,
            (CVMJavaInt)0x06417002,
            (CVMJavaInt)0x06417002,
            (CVMJavaInt)0x06097002,
            (CVMJavaInt)0x06097002,
            (CVMJavaInt)0x07FFF003,
            (CVMJavaInt)0x07FFF003,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x06DA7001,
            (CVMJavaInt)0x06DA7001,
            (CVMJavaInt)0x07FFF003,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x06AA7001,
            (CVMJavaInt)0x06AA7001,
            (CVMJavaInt)0x06727001,
            (CVMJavaInt)0x06727001,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x07E57002,
            (CVMJavaInt)0x06427001,
            (CVMJavaInt)0x06427001,
            (CVMJavaInt)0x07E67001,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x06027001,
            (CVMJavaInt)0x06027001,
            (CVMJavaInt)0x060A7001,
            (CVMJavaInt)0x060A7001,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x6000400C,
            (CVMJavaInt)0x6000400C,
            (CVMJavaInt)0x6000400C,
            (CVMJavaInt)0x6000000C,
            (CVMJavaInt)0x6000400C,
            (CVMJavaInt)0x4800400C,
            (CVMJavaInt)0x00001010,
            (CVMJavaInt)0x08001010,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x6800001D,
            (CVMJavaInt)0x6800001E,
            (CVMJavaInt)0x68000015,
            (CVMJavaInt)0x6800001D,
            (CVMJavaInt)0x6000400D,
            (CVMJavaInt)0x5000400E,
            (CVMJavaInt)0x78001010,
            (CVMJavaInt)0x78001010,
            (CVMJavaInt)0x78001010,
            (CVMJavaInt)0x6000000C,
            (CVMJavaInt)0x28000018,
            (CVMJavaInt)0x28000018,
            (CVMJavaInt)0x28000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)-0x17FFFFE3,
            (CVMJavaInt)-0x17FFFFE2,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68005017,
            (CVMJavaInt)0x68005017,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)-0x17FFFFEB,
            (CVMJavaInt)-0x17FFFFEA,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x1800060B,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x28000019,
            (CVMJavaInt)0x28000019,
            (CVMJavaInt)-0x17FFFFEA,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x1800040B,
            (CVMJavaInt)0x1800040B,
            (CVMJavaInt)0x00007001,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x00007001,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00007001,
            (CVMJavaInt)0x00007001,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x07FE7001,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x07FE7001,
            (CVMJavaInt)0x07FE7001,
            (CVMJavaInt)0x2800001C,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x00007002,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x6800080B,
            (CVMJavaInt)0x0042742A,
            (CVMJavaInt)0x0042742A,
            (CVMJavaInt)0x0042780A,
            (CVMJavaInt)0x0042780A,
            (CVMJavaInt)0x0041762A,
            (CVMJavaInt)0x0041762A,
            (CVMJavaInt)0x0041780A,
            (CVMJavaInt)0x0041780A,
            (CVMJavaInt)0x0000780A,
            (CVMJavaInt)0x0000780A,
            (CVMJavaInt)0x0000780A,
            (CVMJavaInt)0x0000700A,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)-0x17FFFFE7,
            (CVMJavaInt)-0x17FFFFE7,
            (CVMJavaInt)-0x17FFFFE7,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)-0x17FFFFEB,
            (CVMJavaInt)-0x17FFFFEA,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x0000001C,
            (CVMJavaInt)0x1800042B,
            (CVMJavaInt)0x1800042B,
            (CVMJavaInt)0x180005AB,
            (CVMJavaInt)0x180005AB,
            (CVMJavaInt)0x1800072B,
            (CVMJavaInt)0x1800072B,
            (CVMJavaInt)0x006A001C,
            (CVMJavaInt)0x006A001C,
            (CVMJavaInt)0x0069001C,
            (CVMJavaInt)0x0069001C,
            (CVMJavaInt)0x180006CB,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x6800056B,
            (CVMJavaInt)0x6800056B,
            (CVMJavaInt)0x6800042B,
            (CVMJavaInt)0x6800042B,
            (CVMJavaInt)0x680006EB,
            (CVMJavaInt)0x680006EB,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x0000772A,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x68000015,
            (CVMJavaInt)0x68000016,
            (CVMJavaInt)0x68000016,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x0000740A,
            (CVMJavaInt)0x0000740A,
            (CVMJavaInt)0x0000740A,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x0000764A,
            (CVMJavaInt)0x0000776A,
            (CVMJavaInt)0x0000748A,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x68005017,
            (CVMJavaInt)0x0000042B,
            (CVMJavaInt)0x0000042B,
            (CVMJavaInt)0x00000013,
            (CVMJavaInt)0x00000013,
            (CVMJavaInt)0x00000012,
            (CVMJavaInt)0x00000012,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x07FD7002,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x08007005,
            (CVMJavaInt)0x40003006,
            (CVMJavaInt)0x08007005,
            (CVMJavaInt)0x08007005,
            (CVMJavaInt)0x28000019,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x68000014,
            (CVMJavaInt)0x68005017,
            (CVMJavaInt)0x68005017,
            (CVMJavaInt)0x68000015,
            (CVMJavaInt)0x68000016,
            (CVMJavaInt)0x68000015,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68005017,
            (CVMJavaInt)0x68005017,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x38000018,
            (CVMJavaInt)0x68000016,
            (CVMJavaInt)0x28000018,
            (CVMJavaInt)0x28000019,
            (CVMJavaInt)0x28000014,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x78000000,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x2800601A,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x00827FE1,
            (CVMJavaInt)0x68000015,
            (CVMJavaInt)0x68000018,
            (CVMJavaInt)0x68000016,
            (CVMJavaInt)0x00817FE2,
            (CVMJavaInt)0x68000015,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x68000016,
            (CVMJavaInt)0x00007004,
            (CVMJavaInt)0x00007005,
            (CVMJavaInt)0x68000019,
            (CVMJavaInt)0x6800001B,
            (CVMJavaInt)0x6800001C,
            (CVMJavaInt)0x2800601A,
            (CVMJavaInt)0x2800601A,
            (CVMJavaInt)0x78000000
        }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_0_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {223, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_0_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {83, 83, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_1_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {329, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_1_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {700, 78, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_2_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {496, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_2_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {74, 780, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_3_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {912, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_3_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {921, 776, 769, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_4_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {944, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_4_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {933, 776, 769, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_5_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {1415, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_5_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {1333, 1362, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_6_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {7830, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_6_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {72, 817, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_7_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {7831, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_7_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {84, 776, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_8_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {7832, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_8_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {87, 778, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_9_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {7833, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_9_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {89, 778, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_10_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {7834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_10_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {65, 702, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_11_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8016, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_11_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {933, 787, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_12_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8018, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_12_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {933, 787, 768, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_13_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8020, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_13_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {933, 787, 769, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_14_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8022, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_14_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {933, 787, 834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_15_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8064, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_15_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7944, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_16_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8065, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_16_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7945, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_17_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8066, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_17_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7946, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_18_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8067, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_18_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7947, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_19_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8068, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_19_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7948, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_20_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8069, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_20_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7949, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_21_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8070, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_21_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7950, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_22_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8071, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_22_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7951, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_23_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8072, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_23_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7944, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_24_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8073, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_24_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7945, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_25_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8074, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_25_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7946, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_26_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8075, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_26_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7947, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_27_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8076, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_27_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7948, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_28_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8077, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_28_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7949, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_29_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8078, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_29_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7950, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_30_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8079, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_30_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7951, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_31_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8080, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_31_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7976, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_32_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8081, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_32_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7977, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_33_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8082, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_33_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7978, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_34_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8083, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_34_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7979, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_35_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8084, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_35_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7980, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_36_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8085, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_36_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7981, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_37_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8086, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_37_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7982, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_38_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8087, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_38_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7983, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_39_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8088, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_39_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7976, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_40_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8089, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_40_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7977, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_41_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8090, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_41_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7978, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_42_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8091, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_42_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7979, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_43_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8092, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_43_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7980, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_44_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8093, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_44_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7981, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_45_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8094, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_45_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7982, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_46_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8095, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_46_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {7983, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_47_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8096, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_47_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8040, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_48_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8097, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_48_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8041, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_49_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8098, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_49_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8042, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_50_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8099, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_50_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8043, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_51_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8100, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_51_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8044, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_52_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8101, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_52_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8045, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_53_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8102, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_53_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8046, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_54_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8103, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_54_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8047, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_55_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8104, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_55_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8040, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_56_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8105, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_56_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8041, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_57_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8106, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_57_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8042, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_58_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8107, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_58_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8043, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_59_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8108, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_59_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8044, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_60_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8109, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_60_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8045, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_61_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8110, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_61_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8046, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_62_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8111, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_62_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8047, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_63_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8114, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_63_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8122, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_64_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8115, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_64_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {913, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_65_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8116, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_65_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {902, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_66_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8118, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_66_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {913, 834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_67_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8119, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_67_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {913, 834, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_68_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8124, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_68_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {913, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_69_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8130, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_69_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8138, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_70_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8131, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_70_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {919, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_71_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8132, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_71_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {905, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_72_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8134, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_72_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {919, 834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_73_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8135, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_73_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {919, 834, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_74_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8140, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_74_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {919, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_75_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8146, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_75_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {921, 776, 768, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_76_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8147, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_76_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {921, 776, 769, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_77_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8150, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_77_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {921, 834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_78_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8151, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_78_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {921, 776, 834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_79_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8162, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_79_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {933, 776, 768, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_80_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8163, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_80_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {933, 776, 769, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_81_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8164, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_81_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {929, 787, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_82_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8166, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_82_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {933, 834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_83_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8167, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_83_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {933, 776, 834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_84_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8178, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_84_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {8186, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_85_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8179, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_85_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {937, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_86_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8180, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_86_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {911, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_87_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8182, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_87_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {937, 834, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_88_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8183, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_88_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {937, 834, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_89_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {8188, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_89_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {937, 921, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_90_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64256, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_90_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {70, 70, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_91_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64257, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_91_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {70, 73, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_92_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64258, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_92_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {70, 76, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_93_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64259, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_93_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {70, 70, 73, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_94_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64260, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[3];
} CVM_CharacterCharMap_94_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     3, {70, 70, 76, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_95_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64261, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_95_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {83, 84, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_96_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64262, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_96_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {83, 84, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_97_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64275, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_97_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {1348, 1350, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_98_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64276, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_98_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {1348, 1333, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_99_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64277, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_99_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {1348, 1339, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_100_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64278, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_100_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {1358, 1350, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[1];
} CVM_CharacterCharMap_101_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     1, {64279, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     CVMJavaChar charData[2];
} CVM_CharacterCharMap_101_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock,0),
     2, {1348, 1341, }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_0_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
	 /* NOTE: the reason for appending ".hdr" is to work around
	    a suspect GCC strict aliasing warning. */
     (const CVMObject*)&CVM_CharacterCharMap_0_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_0_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_1_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_1_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_1_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_2_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_2_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_2_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_3_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_3_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_3_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_4_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_4_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_4_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_5_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_5_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_5_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_6_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_6_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_6_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_7_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_7_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_7_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_8_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_8_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_8_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_9_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_9_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_9_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_10_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_10_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_10_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_11_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_11_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_11_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_12_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_12_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_12_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_13_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_13_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_13_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_14_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_14_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_14_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_15_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_15_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_15_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_16_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_16_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_16_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_17_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_17_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_17_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_18_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_18_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_18_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_19_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_19_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_19_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_20_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_20_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_20_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_21_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_21_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_21_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_22_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_22_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_22_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_23_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_23_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_23_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_24_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_24_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_24_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_25_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_25_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_25_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_26_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_26_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_26_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_27_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_27_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_27_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_28_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_28_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_28_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_29_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_29_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_29_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_30_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_30_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_30_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_31_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_31_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_31_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_32_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_32_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_32_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_33_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_33_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_33_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_34_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_34_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_34_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_35_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_35_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_35_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_36_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_36_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_36_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_37_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_37_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_37_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_38_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_38_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_38_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_39_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_39_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_39_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_40_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_40_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_40_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_41_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_41_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_41_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_42_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_42_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_42_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_43_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_43_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_43_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_44_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_44_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_44_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_45_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_45_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_45_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_46_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_46_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_46_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_47_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_47_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_47_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_48_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_48_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_48_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_49_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_49_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_49_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_50_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_50_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_50_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_51_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_51_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_51_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_52_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_52_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_52_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_53_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_53_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_53_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_54_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_54_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_54_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_55_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_55_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_55_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_56_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_56_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_56_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_57_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_57_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_57_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_58_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_58_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_58_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_59_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_59_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_59_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_60_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_60_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_60_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_61_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_61_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_61_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_62_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_62_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_62_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_63_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_63_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_63_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_64_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_64_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_64_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_65_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_65_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_65_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_66_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_66_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_66_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_67_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_67_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_67_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_68_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_68_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_68_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_69_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_69_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_69_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_70_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_70_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_70_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_71_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_71_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_71_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_72_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_72_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_72_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_73_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_73_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_73_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_74_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_74_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_74_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_75_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_75_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_75_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_76_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_76_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_76_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_77_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_77_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_77_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_78_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_78_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_78_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_79_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_79_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_79_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_80_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_80_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_80_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_81_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_81_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_81_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_82_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_82_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_82_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_83_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_83_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_83_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_84_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_84_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_84_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_85_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_85_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_85_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_86_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_86_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_86_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_87_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_87_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_87_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_88_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_88_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_88_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_89_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_89_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_89_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_90_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_90_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_90_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_91_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_91_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_91_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_92_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_92_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_92_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_93_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_93_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_93_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_94_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_94_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_94_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_95_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_95_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_95_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_96_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_96_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_96_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_97_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_97_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_97_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_98_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_98_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_98_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_99_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_99_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_99_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_100_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_100_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_100_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[2];
} CVM_CharacterCharMap_101_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     2, {
     (const CVMObject*)&CVM_CharacterCharMap_101_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_101_1_data.hdr,
   }
};

static const struct {
     CVMObjectHeader hdr;
     CVMJavaInt length;
     const CVMObject* arrayData[102];
} CVM_CharacterCharMap_data = {
     CVM_ROM_OBJECT_HDR_INIT0(manufacturedArrayOfByte_Classblock, 0),
     102, {
     (const CVMObject*)&CVM_CharacterCharMap_0_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_1_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_2_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_3_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_4_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_5_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_6_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_7_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_8_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_9_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_10_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_11_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_12_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_13_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_14_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_15_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_16_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_17_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_18_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_19_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_20_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_21_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_22_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_23_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_24_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_25_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_26_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_27_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_28_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_29_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_30_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_31_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_32_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_33_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_34_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_35_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_36_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_37_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_38_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_39_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_40_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_41_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_42_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_43_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_44_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_45_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_46_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_47_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_48_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_49_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_50_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_51_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_52_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_53_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_54_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_55_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_56_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_57_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_58_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_59_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_60_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_61_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_62_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_63_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_64_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_65_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_66_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_67_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_68_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_69_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_70_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_71_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_72_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_73_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_74_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_75_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_76_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_77_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_78_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_79_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_80_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_81_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_82_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_83_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_84_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_85_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_86_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_87_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_88_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_89_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_90_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_91_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_92_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_93_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_94_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_95_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_96_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_97_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_98_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_99_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_100_data.hdr,
     (const CVMObject*)&CVM_CharacterCharMap_101_data.hdr,
   }
};

/*
 * Class:	java/lang/CharacterData
 * Method:	setArrays
 * Signature:	()V
 *
 * This function populates the private char X[], char Y[] and int A[] 
 * arrays of Java with the Romized values.
 */
JNIEXPORT void JNICALL
Java_java_lang_CharacterData_setArrays (JNIEnv* env, jclass cls) {
    CVMExecEnv* ee = CVMjniEnv2ExecEnv(env); 
    CVMID_localrootBegin(ee) {
        CVMID_localrootDeclare(CVMObjectICell, xICell);
        CVMID_localrootDeclare(CVMObjectICell, yICell);
        CVMID_localrootDeclare(CVMObjectICell, aICell);
        CVMID_localrootDeclare(CVMObjectICell, charMapICell);
 
        jfieldID xId;
        jfieldID yId;
        jfieldID aId;
        jfieldID charMapId;

        CVMD_gcUnsafeExec(ee, {
	    /* NOTE: the reason for appending ".hdr" is to work around
	       a suspect GCC strict aliasing warning. */
            CVMID_icellSetDirect(ee, xICell,
				 (CVMObject*)&CVM_CharacterX_data.hdr);
            CVMID_icellSetDirect(ee, yICell,
				 (CVMObject*)&CVM_CharacterY_data.hdr);
            CVMID_icellSetDirect(ee, aICell,
				 (CVMObject*)&CVM_CharacterA_data.hdr);
            CVMID_icellSetDirect(ee, charMapICell,
				 (CVMObject*)&CVM_CharacterCharMap_data.hdr);
        });

        xId = (*env)->GetStaticFieldID(env, cls, "X", "[C");
        yId = (*env)->GetStaticFieldID(env, cls, "Y", "[C");
        aId = (*env)->GetStaticFieldID(env, cls, "A", "[I");
        charMapId = (*env)->GetStaticFieldID(env, cls, "charMap", "[[[C");
        
        /* the argument 4 of the function below is jobject, hence we pass 
         * CVMObjectICell
         */
        (*env)->SetStaticObjectField(env, cls, xId, xICell);
        (*env)->SetStaticObjectField(env, cls, yId, yICell);
        (*env)->SetStaticObjectField(env, cls, aId, aICell);
        (*env)->SetStaticObjectField(env, cls, charMapId, charMapICell);
    } CVMID_localrootEnd();
}

#ifdef CVM_DEBUG_ASSERTS
char * const CVM_CharacterX_data_start = (char* const) &CVM_CharacterX_data;
const  CVMUint32 CVM_CharacterX_data_size = sizeof(CVM_CharacterX_data);
char * const CVM_CharacterY_data_start = (char* const) &CVM_CharacterY_data;
const  CVMUint32 CVM_CharacterY_data_size = sizeof(CVM_CharacterY_data);
char * const CVM_CharacterA_data_start = (char* const) &CVM_CharacterA_data;
const  CVMUint32 CVM_CharacterA_data_size = sizeof(CVM_CharacterA_data);
const  CVMUint32 CVM_CharacterCharMap_data_size[] = {  
      sizeof(CVM_CharacterCharMap_0_0_data),
      sizeof(CVM_CharacterCharMap_0_1_data),
      sizeof(CVM_CharacterCharMap_1_0_data),
      sizeof(CVM_CharacterCharMap_1_1_data),
      sizeof(CVM_CharacterCharMap_2_0_data),
      sizeof(CVM_CharacterCharMap_2_1_data),
      sizeof(CVM_CharacterCharMap_3_0_data),
      sizeof(CVM_CharacterCharMap_3_1_data),
      sizeof(CVM_CharacterCharMap_4_0_data),
      sizeof(CVM_CharacterCharMap_4_1_data),
      sizeof(CVM_CharacterCharMap_5_0_data),
      sizeof(CVM_CharacterCharMap_5_1_data),
      sizeof(CVM_CharacterCharMap_6_0_data),
      sizeof(CVM_CharacterCharMap_6_1_data),
      sizeof(CVM_CharacterCharMap_7_0_data),
      sizeof(CVM_CharacterCharMap_7_1_data),
      sizeof(CVM_CharacterCharMap_8_0_data),
      sizeof(CVM_CharacterCharMap_8_1_data),
      sizeof(CVM_CharacterCharMap_9_0_data),
      sizeof(CVM_CharacterCharMap_9_1_data),
      sizeof(CVM_CharacterCharMap_10_0_data),
      sizeof(CVM_CharacterCharMap_10_1_data),
      sizeof(CVM_CharacterCharMap_11_0_data),
      sizeof(CVM_CharacterCharMap_11_1_data),
      sizeof(CVM_CharacterCharMap_12_0_data),
      sizeof(CVM_CharacterCharMap_12_1_data),
      sizeof(CVM_CharacterCharMap_13_0_data),
      sizeof(CVM_CharacterCharMap_13_1_data),
      sizeof(CVM_CharacterCharMap_14_0_data),
      sizeof(CVM_CharacterCharMap_14_1_data),
      sizeof(CVM_CharacterCharMap_15_0_data),
      sizeof(CVM_CharacterCharMap_15_1_data),
      sizeof(CVM_CharacterCharMap_16_0_data),
      sizeof(CVM_CharacterCharMap_16_1_data),
      sizeof(CVM_CharacterCharMap_17_0_data),
      sizeof(CVM_CharacterCharMap_17_1_data),
      sizeof(CVM_CharacterCharMap_18_0_data),
      sizeof(CVM_CharacterCharMap_18_1_data),
      sizeof(CVM_CharacterCharMap_19_0_data),
      sizeof(CVM_CharacterCharMap_19_1_data),
      sizeof(CVM_CharacterCharMap_20_0_data),
      sizeof(CVM_CharacterCharMap_20_1_data),
      sizeof(CVM_CharacterCharMap_21_0_data),
      sizeof(CVM_CharacterCharMap_21_1_data),
      sizeof(CVM_CharacterCharMap_22_0_data),
      sizeof(CVM_CharacterCharMap_22_1_data),
      sizeof(CVM_CharacterCharMap_23_0_data),
      sizeof(CVM_CharacterCharMap_23_1_data),
      sizeof(CVM_CharacterCharMap_24_0_data),
      sizeof(CVM_CharacterCharMap_24_1_data),
      sizeof(CVM_CharacterCharMap_25_0_data),
      sizeof(CVM_CharacterCharMap_25_1_data),
      sizeof(CVM_CharacterCharMap_26_0_data),
      sizeof(CVM_CharacterCharMap_26_1_data),
      sizeof(CVM_CharacterCharMap_27_0_data),
      sizeof(CVM_CharacterCharMap_27_1_data),
      sizeof(CVM_CharacterCharMap_28_0_data),
      sizeof(CVM_CharacterCharMap_28_1_data),
      sizeof(CVM_CharacterCharMap_29_0_data),
      sizeof(CVM_CharacterCharMap_29_1_data),
      sizeof(CVM_CharacterCharMap_30_0_data),
      sizeof(CVM_CharacterCharMap_30_1_data),
      sizeof(CVM_CharacterCharMap_31_0_data),
      sizeof(CVM_CharacterCharMap_31_1_data),
      sizeof(CVM_CharacterCharMap_32_0_data),
      sizeof(CVM_CharacterCharMap_32_1_data),
      sizeof(CVM_CharacterCharMap_33_0_data),
      sizeof(CVM_CharacterCharMap_33_1_data),
      sizeof(CVM_CharacterCharMap_34_0_data),
      sizeof(CVM_CharacterCharMap_34_1_data),
      sizeof(CVM_CharacterCharMap_35_0_data),
      sizeof(CVM_CharacterCharMap_35_1_data),
      sizeof(CVM_CharacterCharMap_36_0_data),
      sizeof(CVM_CharacterCharMap_36_1_data),
      sizeof(CVM_CharacterCharMap_37_0_data),
      sizeof(CVM_CharacterCharMap_37_1_data),
      sizeof(CVM_CharacterCharMap_38_0_data),
      sizeof(CVM_CharacterCharMap_38_1_data),
      sizeof(CVM_CharacterCharMap_39_0_data),
      sizeof(CVM_CharacterCharMap_39_1_data),
      sizeof(CVM_CharacterCharMap_40_0_data),
      sizeof(CVM_CharacterCharMap_40_1_data),
      sizeof(CVM_CharacterCharMap_41_0_data),
      sizeof(CVM_CharacterCharMap_41_1_data),
      sizeof(CVM_CharacterCharMap_42_0_data),
      sizeof(CVM_CharacterCharMap_42_1_data),
      sizeof(CVM_CharacterCharMap_43_0_data),
      sizeof(CVM_CharacterCharMap_43_1_data),
      sizeof(CVM_CharacterCharMap_44_0_data),
      sizeof(CVM_CharacterCharMap_44_1_data),
      sizeof(CVM_CharacterCharMap_45_0_data),
      sizeof(CVM_CharacterCharMap_45_1_data),
      sizeof(CVM_CharacterCharMap_46_0_data),
      sizeof(CVM_CharacterCharMap_46_1_data),
      sizeof(CVM_CharacterCharMap_47_0_data),
      sizeof(CVM_CharacterCharMap_47_1_data),
      sizeof(CVM_CharacterCharMap_48_0_data),
      sizeof(CVM_CharacterCharMap_48_1_data),
      sizeof(CVM_CharacterCharMap_49_0_data),
      sizeof(CVM_CharacterCharMap_49_1_data),
      sizeof(CVM_CharacterCharMap_50_0_data),
      sizeof(CVM_CharacterCharMap_50_1_data),
      sizeof(CVM_CharacterCharMap_51_0_data),
      sizeof(CVM_CharacterCharMap_51_1_data),
      sizeof(CVM_CharacterCharMap_52_0_data),
      sizeof(CVM_CharacterCharMap_52_1_data),
      sizeof(CVM_CharacterCharMap_53_0_data),
      sizeof(CVM_CharacterCharMap_53_1_data),
      sizeof(CVM_CharacterCharMap_54_0_data),
      sizeof(CVM_CharacterCharMap_54_1_data),
      sizeof(CVM_CharacterCharMap_55_0_data),
      sizeof(CVM_CharacterCharMap_55_1_data),
      sizeof(CVM_CharacterCharMap_56_0_data),
      sizeof(CVM_CharacterCharMap_56_1_data),
      sizeof(CVM_CharacterCharMap_57_0_data),
      sizeof(CVM_CharacterCharMap_57_1_data),
      sizeof(CVM_CharacterCharMap_58_0_data),
      sizeof(CVM_CharacterCharMap_58_1_data),
      sizeof(CVM_CharacterCharMap_59_0_data),
      sizeof(CVM_CharacterCharMap_59_1_data),
      sizeof(CVM_CharacterCharMap_60_0_data),
      sizeof(CVM_CharacterCharMap_60_1_data),
      sizeof(CVM_CharacterCharMap_61_0_data),
      sizeof(CVM_CharacterCharMap_61_1_data),
      sizeof(CVM_CharacterCharMap_62_0_data),
      sizeof(CVM_CharacterCharMap_62_1_data),
      sizeof(CVM_CharacterCharMap_63_0_data),
      sizeof(CVM_CharacterCharMap_63_1_data),
      sizeof(CVM_CharacterCharMap_64_0_data),
      sizeof(CVM_CharacterCharMap_64_1_data),
      sizeof(CVM_CharacterCharMap_65_0_data),
      sizeof(CVM_CharacterCharMap_65_1_data),
      sizeof(CVM_CharacterCharMap_66_0_data),
      sizeof(CVM_CharacterCharMap_66_1_data),
      sizeof(CVM_CharacterCharMap_67_0_data),
      sizeof(CVM_CharacterCharMap_67_1_data),
      sizeof(CVM_CharacterCharMap_68_0_data),
      sizeof(CVM_CharacterCharMap_68_1_data),
      sizeof(CVM_CharacterCharMap_69_0_data),
      sizeof(CVM_CharacterCharMap_69_1_data),
      sizeof(CVM_CharacterCharMap_70_0_data),
      sizeof(CVM_CharacterCharMap_70_1_data),
      sizeof(CVM_CharacterCharMap_71_0_data),
      sizeof(CVM_CharacterCharMap_71_1_data),
      sizeof(CVM_CharacterCharMap_72_0_data),
      sizeof(CVM_CharacterCharMap_72_1_data),
      sizeof(CVM_CharacterCharMap_73_0_data),
      sizeof(CVM_CharacterCharMap_73_1_data),
      sizeof(CVM_CharacterCharMap_74_0_data),
      sizeof(CVM_CharacterCharMap_74_1_data),
      sizeof(CVM_CharacterCharMap_75_0_data),
      sizeof(CVM_CharacterCharMap_75_1_data),
      sizeof(CVM_CharacterCharMap_76_0_data),
      sizeof(CVM_CharacterCharMap_76_1_data),
      sizeof(CVM_CharacterCharMap_77_0_data),
      sizeof(CVM_CharacterCharMap_77_1_data),
      sizeof(CVM_CharacterCharMap_78_0_data),
      sizeof(CVM_CharacterCharMap_78_1_data),
      sizeof(CVM_CharacterCharMap_79_0_data),
      sizeof(CVM_CharacterCharMap_79_1_data),
      sizeof(CVM_CharacterCharMap_80_0_data),
      sizeof(CVM_CharacterCharMap_80_1_data),
      sizeof(CVM_CharacterCharMap_81_0_data),
      sizeof(CVM_CharacterCharMap_81_1_data),
      sizeof(CVM_CharacterCharMap_82_0_data),
      sizeof(CVM_CharacterCharMap_82_1_data),
      sizeof(CVM_CharacterCharMap_83_0_data),
      sizeof(CVM_CharacterCharMap_83_1_data),
      sizeof(CVM_CharacterCharMap_84_0_data),
      sizeof(CVM_CharacterCharMap_84_1_data),
      sizeof(CVM_CharacterCharMap_85_0_data),
      sizeof(CVM_CharacterCharMap_85_1_data),
      sizeof(CVM_CharacterCharMap_86_0_data),
      sizeof(CVM_CharacterCharMap_86_1_data),
      sizeof(CVM_CharacterCharMap_87_0_data),
      sizeof(CVM_CharacterCharMap_87_1_data),
      sizeof(CVM_CharacterCharMap_88_0_data),
      sizeof(CVM_CharacterCharMap_88_1_data),
      sizeof(CVM_CharacterCharMap_89_0_data),
      sizeof(CVM_CharacterCharMap_89_1_data),
      sizeof(CVM_CharacterCharMap_90_0_data),
      sizeof(CVM_CharacterCharMap_90_1_data),
      sizeof(CVM_CharacterCharMap_91_0_data),
      sizeof(CVM_CharacterCharMap_91_1_data),
      sizeof(CVM_CharacterCharMap_92_0_data),
      sizeof(CVM_CharacterCharMap_92_1_data),
      sizeof(CVM_CharacterCharMap_93_0_data),
      sizeof(CVM_CharacterCharMap_93_1_data),
      sizeof(CVM_CharacterCharMap_94_0_data),
      sizeof(CVM_CharacterCharMap_94_1_data),
      sizeof(CVM_CharacterCharMap_95_0_data),
      sizeof(CVM_CharacterCharMap_95_1_data),
      sizeof(CVM_CharacterCharMap_96_0_data),
      sizeof(CVM_CharacterCharMap_96_1_data),
      sizeof(CVM_CharacterCharMap_97_0_data),
      sizeof(CVM_CharacterCharMap_97_1_data),
      sizeof(CVM_CharacterCharMap_98_0_data),
      sizeof(CVM_CharacterCharMap_98_1_data),
      sizeof(CVM_CharacterCharMap_99_0_data),
      sizeof(CVM_CharacterCharMap_99_1_data),
      sizeof(CVM_CharacterCharMap_100_0_data),
      sizeof(CVM_CharacterCharMap_100_1_data),
      sizeof(CVM_CharacterCharMap_101_0_data),
      sizeof(CVM_CharacterCharMap_101_1_data),
      sizeof(CVM_CharacterCharMap_0_data),
      sizeof(CVM_CharacterCharMap_1_data),
      sizeof(CVM_CharacterCharMap_2_data),
      sizeof(CVM_CharacterCharMap_3_data),
      sizeof(CVM_CharacterCharMap_4_data),
      sizeof(CVM_CharacterCharMap_5_data),
      sizeof(CVM_CharacterCharMap_6_data),
      sizeof(CVM_CharacterCharMap_7_data),
      sizeof(CVM_CharacterCharMap_8_data),
      sizeof(CVM_CharacterCharMap_9_data),
      sizeof(CVM_CharacterCharMap_10_data),
      sizeof(CVM_CharacterCharMap_11_data),
      sizeof(CVM_CharacterCharMap_12_data),
      sizeof(CVM_CharacterCharMap_13_data),
      sizeof(CVM_CharacterCharMap_14_data),
      sizeof(CVM_CharacterCharMap_15_data),
      sizeof(CVM_CharacterCharMap_16_data),
      sizeof(CVM_CharacterCharMap_17_data),
      sizeof(CVM_CharacterCharMap_18_data),
      sizeof(CVM_CharacterCharMap_19_data),
      sizeof(CVM_CharacterCharMap_20_data),
      sizeof(CVM_CharacterCharMap_21_data),
      sizeof(CVM_CharacterCharMap_22_data),
      sizeof(CVM_CharacterCharMap_23_data),
      sizeof(CVM_CharacterCharMap_24_data),
      sizeof(CVM_CharacterCharMap_25_data),
      sizeof(CVM_CharacterCharMap_26_data),
      sizeof(CVM_CharacterCharMap_27_data),
      sizeof(CVM_CharacterCharMap_28_data),
      sizeof(CVM_CharacterCharMap_29_data),
      sizeof(CVM_CharacterCharMap_30_data),
      sizeof(CVM_CharacterCharMap_31_data),
      sizeof(CVM_CharacterCharMap_32_data),
      sizeof(CVM_CharacterCharMap_33_data),
      sizeof(CVM_CharacterCharMap_34_data),
      sizeof(CVM_CharacterCharMap_35_data),
      sizeof(CVM_CharacterCharMap_36_data),
      sizeof(CVM_CharacterCharMap_37_data),
      sizeof(CVM_CharacterCharMap_38_data),
      sizeof(CVM_CharacterCharMap_39_data),
      sizeof(CVM_CharacterCharMap_40_data),
      sizeof(CVM_CharacterCharMap_41_data),
      sizeof(CVM_CharacterCharMap_42_data),
      sizeof(CVM_CharacterCharMap_43_data),
      sizeof(CVM_CharacterCharMap_44_data),
      sizeof(CVM_CharacterCharMap_45_data),
      sizeof(CVM_CharacterCharMap_46_data),
      sizeof(CVM_CharacterCharMap_47_data),
      sizeof(CVM_CharacterCharMap_48_data),
      sizeof(CVM_CharacterCharMap_49_data),
      sizeof(CVM_CharacterCharMap_50_data),
      sizeof(CVM_CharacterCharMap_51_data),
      sizeof(CVM_CharacterCharMap_52_data),
      sizeof(CVM_CharacterCharMap_53_data),
      sizeof(CVM_CharacterCharMap_54_data),
      sizeof(CVM_CharacterCharMap_55_data),
      sizeof(CVM_CharacterCharMap_56_data),
      sizeof(CVM_CharacterCharMap_57_data),
      sizeof(CVM_CharacterCharMap_58_data),
      sizeof(CVM_CharacterCharMap_59_data),
      sizeof(CVM_CharacterCharMap_60_data),
      sizeof(CVM_CharacterCharMap_61_data),
      sizeof(CVM_CharacterCharMap_62_data),
      sizeof(CVM_CharacterCharMap_63_data),
      sizeof(CVM_CharacterCharMap_64_data),
      sizeof(CVM_CharacterCharMap_65_data),
      sizeof(CVM_CharacterCharMap_66_data),
      sizeof(CVM_CharacterCharMap_67_data),
      sizeof(CVM_CharacterCharMap_68_data),
      sizeof(CVM_CharacterCharMap_69_data),
      sizeof(CVM_CharacterCharMap_70_data),
      sizeof(CVM_CharacterCharMap_71_data),
      sizeof(CVM_CharacterCharMap_72_data),
      sizeof(CVM_CharacterCharMap_73_data),
      sizeof(CVM_CharacterCharMap_74_data),
      sizeof(CVM_CharacterCharMap_75_data),
      sizeof(CVM_CharacterCharMap_76_data),
      sizeof(CVM_CharacterCharMap_77_data),
      sizeof(CVM_CharacterCharMap_78_data),
      sizeof(CVM_CharacterCharMap_79_data),
      sizeof(CVM_CharacterCharMap_80_data),
      sizeof(CVM_CharacterCharMap_81_data),
      sizeof(CVM_CharacterCharMap_82_data),
      sizeof(CVM_CharacterCharMap_83_data),
      sizeof(CVM_CharacterCharMap_84_data),
      sizeof(CVM_CharacterCharMap_85_data),
      sizeof(CVM_CharacterCharMap_86_data),
      sizeof(CVM_CharacterCharMap_87_data),
      sizeof(CVM_CharacterCharMap_88_data),
      sizeof(CVM_CharacterCharMap_89_data),
      sizeof(CVM_CharacterCharMap_90_data),
      sizeof(CVM_CharacterCharMap_91_data),
      sizeof(CVM_CharacterCharMap_92_data),
      sizeof(CVM_CharacterCharMap_93_data),
      sizeof(CVM_CharacterCharMap_94_data),
      sizeof(CVM_CharacterCharMap_95_data),
      sizeof(CVM_CharacterCharMap_96_data),
      sizeof(CVM_CharacterCharMap_97_data),
      sizeof(CVM_CharacterCharMap_98_data),
      sizeof(CVM_CharacterCharMap_99_data),
      sizeof(CVM_CharacterCharMap_100_data),
      sizeof(CVM_CharacterCharMap_101_data),
      sizeof(CVM_CharacterCharMap_data),
};

const char * const CVM_CharacterCharMap_data_start[] = {
       (char* const) &CVM_CharacterCharMap_0_0_data,
       (char* const) &CVM_CharacterCharMap_0_1_data,
       (char* const) &CVM_CharacterCharMap_1_0_data,
       (char* const) &CVM_CharacterCharMap_1_1_data,
       (char* const) &CVM_CharacterCharMap_2_0_data,
       (char* const) &CVM_CharacterCharMap_2_1_data,
       (char* const) &CVM_CharacterCharMap_3_0_data,
       (char* const) &CVM_CharacterCharMap_3_1_data,
       (char* const) &CVM_CharacterCharMap_4_0_data,
       (char* const) &CVM_CharacterCharMap_4_1_data,
       (char* const) &CVM_CharacterCharMap_5_0_data,
       (char* const) &CVM_CharacterCharMap_5_1_data,
       (char* const) &CVM_CharacterCharMap_6_0_data,
       (char* const) &CVM_CharacterCharMap_6_1_data,
       (char* const) &CVM_CharacterCharMap_7_0_data,
       (char* const) &CVM_CharacterCharMap_7_1_data,
       (char* const) &CVM_CharacterCharMap_8_0_data,
       (char* const) &CVM_CharacterCharMap_8_1_data,
       (char* const) &CVM_CharacterCharMap_9_0_data,
       (char* const) &CVM_CharacterCharMap_9_1_data,
       (char* const) &CVM_CharacterCharMap_10_0_data,
       (char* const) &CVM_CharacterCharMap_10_1_data,
       (char* const) &CVM_CharacterCharMap_11_0_data,
       (char* const) &CVM_CharacterCharMap_11_1_data,
       (char* const) &CVM_CharacterCharMap_12_0_data,
       (char* const) &CVM_CharacterCharMap_12_1_data,
       (char* const) &CVM_CharacterCharMap_13_0_data,
       (char* const) &CVM_CharacterCharMap_13_1_data,
       (char* const) &CVM_CharacterCharMap_14_0_data,
       (char* const) &CVM_CharacterCharMap_14_1_data,
       (char* const) &CVM_CharacterCharMap_15_0_data,
       (char* const) &CVM_CharacterCharMap_15_1_data,
       (char* const) &CVM_CharacterCharMap_16_0_data,
       (char* const) &CVM_CharacterCharMap_16_1_data,
       (char* const) &CVM_CharacterCharMap_17_0_data,
       (char* const) &CVM_CharacterCharMap_17_1_data,
       (char* const) &CVM_CharacterCharMap_18_0_data,
       (char* const) &CVM_CharacterCharMap_18_1_data,
       (char* const) &CVM_CharacterCharMap_19_0_data,
       (char* const) &CVM_CharacterCharMap_19_1_data,
       (char* const) &CVM_CharacterCharMap_20_0_data,
       (char* const) &CVM_CharacterCharMap_20_1_data,
       (char* const) &CVM_CharacterCharMap_21_0_data,
       (char* const) &CVM_CharacterCharMap_21_1_data,
       (char* const) &CVM_CharacterCharMap_22_0_data,
       (char* const) &CVM_CharacterCharMap_22_1_data,
       (char* const) &CVM_CharacterCharMap_23_0_data,
       (char* const) &CVM_CharacterCharMap_23_1_data,
       (char* const) &CVM_CharacterCharMap_24_0_data,
       (char* const) &CVM_CharacterCharMap_24_1_data,
       (char* const) &CVM_CharacterCharMap_25_0_data,
       (char* const) &CVM_CharacterCharMap_25_1_data,
       (char* const) &CVM_CharacterCharMap_26_0_data,
       (char* const) &CVM_CharacterCharMap_26_1_data,
       (char* const) &CVM_CharacterCharMap_27_0_data,
       (char* const) &CVM_CharacterCharMap_27_1_data,
       (char* const) &CVM_CharacterCharMap_28_0_data,
       (char* const) &CVM_CharacterCharMap_28_1_data,
       (char* const) &CVM_CharacterCharMap_29_0_data,
       (char* const) &CVM_CharacterCharMap_29_1_data,
       (char* const) &CVM_CharacterCharMap_30_0_data,
       (char* const) &CVM_CharacterCharMap_30_1_data,
       (char* const) &CVM_CharacterCharMap_31_0_data,
       (char* const) &CVM_CharacterCharMap_31_1_data,
       (char* const) &CVM_CharacterCharMap_32_0_data,
       (char* const) &CVM_CharacterCharMap_32_1_data,
       (char* const) &CVM_CharacterCharMap_33_0_data,
       (char* const) &CVM_CharacterCharMap_33_1_data,
       (char* const) &CVM_CharacterCharMap_34_0_data,
       (char* const) &CVM_CharacterCharMap_34_1_data,
       (char* const) &CVM_CharacterCharMap_35_0_data,
       (char* const) &CVM_CharacterCharMap_35_1_data,
       (char* const) &CVM_CharacterCharMap_36_0_data,
       (char* const) &CVM_CharacterCharMap_36_1_data,
       (char* const) &CVM_CharacterCharMap_37_0_data,
       (char* const) &CVM_CharacterCharMap_37_1_data,
       (char* const) &CVM_CharacterCharMap_38_0_data,
       (char* const) &CVM_CharacterCharMap_38_1_data,
       (char* const) &CVM_CharacterCharMap_39_0_data,
       (char* const) &CVM_CharacterCharMap_39_1_data,
       (char* const) &CVM_CharacterCharMap_40_0_data,
       (char* const) &CVM_CharacterCharMap_40_1_data,
       (char* const) &CVM_CharacterCharMap_41_0_data,
       (char* const) &CVM_CharacterCharMap_41_1_data,
       (char* const) &CVM_CharacterCharMap_42_0_data,
       (char* const) &CVM_CharacterCharMap_42_1_data,
       (char* const) &CVM_CharacterCharMap_43_0_data,
       (char* const) &CVM_CharacterCharMap_43_1_data,
       (char* const) &CVM_CharacterCharMap_44_0_data,
       (char* const) &CVM_CharacterCharMap_44_1_data,
       (char* const) &CVM_CharacterCharMap_45_0_data,
       (char* const) &CVM_CharacterCharMap_45_1_data,
       (char* const) &CVM_CharacterCharMap_46_0_data,
       (char* const) &CVM_CharacterCharMap_46_1_data,
       (char* const) &CVM_CharacterCharMap_47_0_data,
       (char* const) &CVM_CharacterCharMap_47_1_data,
       (char* const) &CVM_CharacterCharMap_48_0_data,
       (char* const) &CVM_CharacterCharMap_48_1_data,
       (char* const) &CVM_CharacterCharMap_49_0_data,
       (char* const) &CVM_CharacterCharMap_49_1_data,
       (char* const) &CVM_CharacterCharMap_50_0_data,
       (char* const) &CVM_CharacterCharMap_50_1_data,
       (char* const) &CVM_CharacterCharMap_51_0_data,
       (char* const) &CVM_CharacterCharMap_51_1_data,
       (char* const) &CVM_CharacterCharMap_52_0_data,
       (char* const) &CVM_CharacterCharMap_52_1_data,
       (char* const) &CVM_CharacterCharMap_53_0_data,
       (char* const) &CVM_CharacterCharMap_53_1_data,
       (char* const) &CVM_CharacterCharMap_54_0_data,
       (char* const) &CVM_CharacterCharMap_54_1_data,
       (char* const) &CVM_CharacterCharMap_55_0_data,
       (char* const) &CVM_CharacterCharMap_55_1_data,
       (char* const) &CVM_CharacterCharMap_56_0_data,
       (char* const) &CVM_CharacterCharMap_56_1_data,
       (char* const) &CVM_CharacterCharMap_57_0_data,
       (char* const) &CVM_CharacterCharMap_57_1_data,
       (char* const) &CVM_CharacterCharMap_58_0_data,
       (char* const) &CVM_CharacterCharMap_58_1_data,
       (char* const) &CVM_CharacterCharMap_59_0_data,
       (char* const) &CVM_CharacterCharMap_59_1_data,
       (char* const) &CVM_CharacterCharMap_60_0_data,
       (char* const) &CVM_CharacterCharMap_60_1_data,
       (char* const) &CVM_CharacterCharMap_61_0_data,
       (char* const) &CVM_CharacterCharMap_61_1_data,
       (char* const) &CVM_CharacterCharMap_62_0_data,
       (char* const) &CVM_CharacterCharMap_62_1_data,
       (char* const) &CVM_CharacterCharMap_63_0_data,
       (char* const) &CVM_CharacterCharMap_63_1_data,
       (char* const) &CVM_CharacterCharMap_64_0_data,
       (char* const) &CVM_CharacterCharMap_64_1_data,
       (char* const) &CVM_CharacterCharMap_65_0_data,
       (char* const) &CVM_CharacterCharMap_65_1_data,
       (char* const) &CVM_CharacterCharMap_66_0_data,
       (char* const) &CVM_CharacterCharMap_66_1_data,
       (char* const) &CVM_CharacterCharMap_67_0_data,
       (char* const) &CVM_CharacterCharMap_67_1_data,
       (char* const) &CVM_CharacterCharMap_68_0_data,
       (char* const) &CVM_CharacterCharMap_68_1_data,
       (char* const) &CVM_CharacterCharMap_69_0_data,
       (char* const) &CVM_CharacterCharMap_69_1_data,
       (char* const) &CVM_CharacterCharMap_70_0_data,
       (char* const) &CVM_CharacterCharMap_70_1_data,
       (char* const) &CVM_CharacterCharMap_71_0_data,
       (char* const) &CVM_CharacterCharMap_71_1_data,
       (char* const) &CVM_CharacterCharMap_72_0_data,
       (char* const) &CVM_CharacterCharMap_72_1_data,
       (char* const) &CVM_CharacterCharMap_73_0_data,
       (char* const) &CVM_CharacterCharMap_73_1_data,
       (char* const) &CVM_CharacterCharMap_74_0_data,
       (char* const) &CVM_CharacterCharMap_74_1_data,
       (char* const) &CVM_CharacterCharMap_75_0_data,
       (char* const) &CVM_CharacterCharMap_75_1_data,
       (char* const) &CVM_CharacterCharMap_76_0_data,
       (char* const) &CVM_CharacterCharMap_76_1_data,
       (char* const) &CVM_CharacterCharMap_77_0_data,
       (char* const) &CVM_CharacterCharMap_77_1_data,
       (char* const) &CVM_CharacterCharMap_78_0_data,
       (char* const) &CVM_CharacterCharMap_78_1_data,
       (char* const) &CVM_CharacterCharMap_79_0_data,
       (char* const) &CVM_CharacterCharMap_79_1_data,
       (char* const) &CVM_CharacterCharMap_80_0_data,
       (char* const) &CVM_CharacterCharMap_80_1_data,
       (char* const) &CVM_CharacterCharMap_81_0_data,
       (char* const) &CVM_CharacterCharMap_81_1_data,
       (char* const) &CVM_CharacterCharMap_82_0_data,
       (char* const) &CVM_CharacterCharMap_82_1_data,
       (char* const) &CVM_CharacterCharMap_83_0_data,
       (char* const) &CVM_CharacterCharMap_83_1_data,
       (char* const) &CVM_CharacterCharMap_84_0_data,
       (char* const) &CVM_CharacterCharMap_84_1_data,
       (char* const) &CVM_CharacterCharMap_85_0_data,
       (char* const) &CVM_CharacterCharMap_85_1_data,
       (char* const) &CVM_CharacterCharMap_86_0_data,
       (char* const) &CVM_CharacterCharMap_86_1_data,
       (char* const) &CVM_CharacterCharMap_87_0_data,
       (char* const) &CVM_CharacterCharMap_87_1_data,
       (char* const) &CVM_CharacterCharMap_88_0_data,
       (char* const) &CVM_CharacterCharMap_88_1_data,
       (char* const) &CVM_CharacterCharMap_89_0_data,
       (char* const) &CVM_CharacterCharMap_89_1_data,
       (char* const) &CVM_CharacterCharMap_90_0_data,
       (char* const) &CVM_CharacterCharMap_90_1_data,
       (char* const) &CVM_CharacterCharMap_91_0_data,
       (char* const) &CVM_CharacterCharMap_91_1_data,
       (char* const) &CVM_CharacterCharMap_92_0_data,
       (char* const) &CVM_CharacterCharMap_92_1_data,
       (char* const) &CVM_CharacterCharMap_93_0_data,
       (char* const) &CVM_CharacterCharMap_93_1_data,
       (char* const) &CVM_CharacterCharMap_94_0_data,
       (char* const) &CVM_CharacterCharMap_94_1_data,
       (char* const) &CVM_CharacterCharMap_95_0_data,
       (char* const) &CVM_CharacterCharMap_95_1_data,
       (char* const) &CVM_CharacterCharMap_96_0_data,
       (char* const) &CVM_CharacterCharMap_96_1_data,
       (char* const) &CVM_CharacterCharMap_97_0_data,
       (char* const) &CVM_CharacterCharMap_97_1_data,
       (char* const) &CVM_CharacterCharMap_98_0_data,
       (char* const) &CVM_CharacterCharMap_98_1_data,
       (char* const) &CVM_CharacterCharMap_99_0_data,
       (char* const) &CVM_CharacterCharMap_99_1_data,
       (char* const) &CVM_CharacterCharMap_100_0_data,
       (char* const) &CVM_CharacterCharMap_100_1_data,
       (char* const) &CVM_CharacterCharMap_101_0_data,
       (char* const) &CVM_CharacterCharMap_101_1_data,
       (char* const) &CVM_CharacterCharMap_0_data,
       (char* const) &CVM_CharacterCharMap_1_data,
       (char* const) &CVM_CharacterCharMap_2_data,
       (char* const) &CVM_CharacterCharMap_3_data,
       (char* const) &CVM_CharacterCharMap_4_data,
       (char* const) &CVM_CharacterCharMap_5_data,
       (char* const) &CVM_CharacterCharMap_6_data,
       (char* const) &CVM_CharacterCharMap_7_data,
       (char* const) &CVM_CharacterCharMap_8_data,
       (char* const) &CVM_CharacterCharMap_9_data,
       (char* const) &CVM_CharacterCharMap_10_data,
       (char* const) &CVM_CharacterCharMap_11_data,
       (char* const) &CVM_CharacterCharMap_12_data,
       (char* const) &CVM_CharacterCharMap_13_data,
       (char* const) &CVM_CharacterCharMap_14_data,
       (char* const) &CVM_CharacterCharMap_15_data,
       (char* const) &CVM_CharacterCharMap_16_data,
       (char* const) &CVM_CharacterCharMap_17_data,
       (char* const) &CVM_CharacterCharMap_18_data,
       (char* const) &CVM_CharacterCharMap_19_data,
       (char* const) &CVM_CharacterCharMap_20_data,
       (char* const) &CVM_CharacterCharMap_21_data,
       (char* const) &CVM_CharacterCharMap_22_data,
       (char* const) &CVM_CharacterCharMap_23_data,
       (char* const) &CVM_CharacterCharMap_24_data,
       (char* const) &CVM_CharacterCharMap_25_data,
       (char* const) &CVM_CharacterCharMap_26_data,
       (char* const) &CVM_CharacterCharMap_27_data,
       (char* const) &CVM_CharacterCharMap_28_data,
       (char* const) &CVM_CharacterCharMap_29_data,
       (char* const) &CVM_CharacterCharMap_30_data,
       (char* const) &CVM_CharacterCharMap_31_data,
       (char* const) &CVM_CharacterCharMap_32_data,
       (char* const) &CVM_CharacterCharMap_33_data,
       (char* const) &CVM_CharacterCharMap_34_data,
       (char* const) &CVM_CharacterCharMap_35_data,
       (char* const) &CVM_CharacterCharMap_36_data,
       (char* const) &CVM_CharacterCharMap_37_data,
       (char* const) &CVM_CharacterCharMap_38_data,
       (char* const) &CVM_CharacterCharMap_39_data,
       (char* const) &CVM_CharacterCharMap_40_data,
       (char* const) &CVM_CharacterCharMap_41_data,
       (char* const) &CVM_CharacterCharMap_42_data,
       (char* const) &CVM_CharacterCharMap_43_data,
       (char* const) &CVM_CharacterCharMap_44_data,
       (char* const) &CVM_CharacterCharMap_45_data,
       (char* const) &CVM_CharacterCharMap_46_data,
       (char* const) &CVM_CharacterCharMap_47_data,
       (char* const) &CVM_CharacterCharMap_48_data,
       (char* const) &CVM_CharacterCharMap_49_data,
       (char* const) &CVM_CharacterCharMap_50_data,
       (char* const) &CVM_CharacterCharMap_51_data,
       (char* const) &CVM_CharacterCharMap_52_data,
       (char* const) &CVM_CharacterCharMap_53_data,
       (char* const) &CVM_CharacterCharMap_54_data,
       (char* const) &CVM_CharacterCharMap_55_data,
       (char* const) &CVM_CharacterCharMap_56_data,
       (char* const) &CVM_CharacterCharMap_57_data,
       (char* const) &CVM_CharacterCharMap_58_data,
       (char* const) &CVM_CharacterCharMap_59_data,
       (char* const) &CVM_CharacterCharMap_60_data,
       (char* const) &CVM_CharacterCharMap_61_data,
       (char* const) &CVM_CharacterCharMap_62_data,
       (char* const) &CVM_CharacterCharMap_63_data,
       (char* const) &CVM_CharacterCharMap_64_data,
       (char* const) &CVM_CharacterCharMap_65_data,
       (char* const) &CVM_CharacterCharMap_66_data,
       (char* const) &CVM_CharacterCharMap_67_data,
       (char* const) &CVM_CharacterCharMap_68_data,
       (char* const) &CVM_CharacterCharMap_69_data,
       (char* const) &CVM_CharacterCharMap_70_data,
       (char* const) &CVM_CharacterCharMap_71_data,
       (char* const) &CVM_CharacterCharMap_72_data,
       (char* const) &CVM_CharacterCharMap_73_data,
       (char* const) &CVM_CharacterCharMap_74_data,
       (char* const) &CVM_CharacterCharMap_75_data,
       (char* const) &CVM_CharacterCharMap_76_data,
       (char* const) &CVM_CharacterCharMap_77_data,
       (char* const) &CVM_CharacterCharMap_78_data,
       (char* const) &CVM_CharacterCharMap_79_data,
       (char* const) &CVM_CharacterCharMap_80_data,
       (char* const) &CVM_CharacterCharMap_81_data,
       (char* const) &CVM_CharacterCharMap_82_data,
       (char* const) &CVM_CharacterCharMap_83_data,
       (char* const) &CVM_CharacterCharMap_84_data,
       (char* const) &CVM_CharacterCharMap_85_data,
       (char* const) &CVM_CharacterCharMap_86_data,
       (char* const) &CVM_CharacterCharMap_87_data,
       (char* const) &CVM_CharacterCharMap_88_data,
       (char* const) &CVM_CharacterCharMap_89_data,
       (char* const) &CVM_CharacterCharMap_90_data,
       (char* const) &CVM_CharacterCharMap_91_data,
       (char* const) &CVM_CharacterCharMap_92_data,
       (char* const) &CVM_CharacterCharMap_93_data,
       (char* const) &CVM_CharacterCharMap_94_data,
       (char* const) &CVM_CharacterCharMap_95_data,
       (char* const) &CVM_CharacterCharMap_96_data,
       (char* const) &CVM_CharacterCharMap_97_data,
       (char* const) &CVM_CharacterCharMap_98_data,
       (char* const) &CVM_CharacterCharMap_99_data,
       (char* const) &CVM_CharacterCharMap_100_data,
       (char* const) &CVM_CharacterCharMap_101_data,
       (char* const) &CVM_CharacterCharMap_data,
};
const CVMUint32 CVM_CharacterCharMap_number_of_elements =
     sizeof(CVM_CharacterCharMap_data_size)/sizeof(CVM_CharacterCharMap_data_size[0]);
#endif
